using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace HarborMist
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        us.geocoder.rpc.GeoCode_Service geoCodeService = new us.geocoder.rpc.GeoCode_Service();


        private void statusWarn(string myWarning)
        {
            try
            {
                statusLabel.BackColor = Color.Yellow;
                statusLabel.Text = myWarning;
            }
            catch 
            {
            }
        }


        private void statusShow(string myStatusMessage)
        {
            try
            {
                statusLabel.BackColor = Color.LightGray;
                statusLabel.Text = myStatusMessage;
            }
            catch
            {
            }
        }


        private void statusClear()
        {
             try
            {
                statusLabel.BackColor = Color.LightGray;
                statusLabel.Text = "";
            }
            catch
            {
            }
        }


        private void buttonLookup_Click(object sender, EventArgs e)
        {
            try
            {
                buttonLookup.Enabled = false;
                if (textBoxAddress.Text.Length > 0)
                {
                    statusShow("Lookup in progress.  Please wait...");

                    geoCodeService.geocode_addressCompleted +=
                        new HarborMist.us.geocoder.rpc.geocode_addressCompletedEventHandler(getIt);
 
                    geoCodeService.geocode_addressAsync(textBoxAddress.Text);
                }
                else
                {
                    statusWarn("You must enter 'street address, city, state zip' in top area");
                    this.buttonLookup.Enabled = true;
                }
            }
            catch (Exception ex)
            {
                ex.ToString();
                statusShow("The lookup failed.  Required format is 'street address, city, state zip'");
            }
        }


        private void getIt(object sender, us.geocoder.rpc.geocode_addressCompletedEventArgs e)
        {
            try
            {
                this.textBoxLat.Text = e.Result[0].lat.ToString();
                this.textBoxLong.Text = e.Result[0].@long.ToString();

                if (textBoxLat.Text == "0")
                {
                    statusWarn("Invalid results.  Required format is 'street address, city, state zip'");
                }
                else
                {
                    statusShow("Results appear to be valid.");
                }
                this.buttonLookup.Enabled = true;
            }
            catch (Exception ex)
            {
                ex.ToString();
                statusShow("This lookup failed.  Required format is 'street address, city, state zip'");
                this.buttonLookup.Enabled = true;
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            try
            {
                this.Text = Application.ProductName + " " + Program.VersionShort;
                geoCodeService.geocode_addressCompleted +=
                        new HarborMist.us.geocoder.rpc.geocode_addressCompletedEventHandler(getIt);
            }
            catch (Exception ex)
            {
                throw new Exception(ex.Message);
            }
        }


    }
}